#pragma once

#include "OwnedUnrealSharedTexture.h"

typedef struct ID3D11Device;
typedef struct ID3D11Texture2D;
typedef struct IDXGIResource;

class OwnedUnrealSharedTexture_D3D11 : public OwnedUnrealSharedTexture
{
private:
	ID3D11Device* device = NULL;
	ID3D11Texture2D* sharedTex = NULL;
	IDXGIResource* dxgi_res = NULL;

#if MIXCAST_D3D12
	FTexture2DRHIRef sharedTexRhi;
#endif

	virtual void Write_RenderThread(FRHICommandListImmediate& RHICmdList) override;

public:
	OwnedUnrealSharedTexture_D3D11(UTexture* srcTex);
	virtual void BeginDestroy() override;
};